package dev.shadowsoffire.apotheosis.mixin;

import it.unimi.dsi.fastutil.ints.IntOpenHashSet;
import net.minecraft.world.phys.EntityHitResult;
import org.spongepowered.asm.mixin.injection.At;
import org.spongepowered.asm.mixin.injection.Inject;
import net.minecraft.world.item.enchantment.Enchantments;
import org.spongepowered.asm.mixin.injection.callback.CallbackInfo;
import org.spongepowered.asm.mixin.gen.Accessor;
import net.minecraft.world.item.ItemStack;
import net.minecraft.world.level.Level;
import net.minecraft.world.entity.EntityType;
import org.spongepowered.asm.mixin.Shadow;
import net.minecraft.world.phys.Vec3;
import net.minecraft.world.entity.projectile.ThrownTrident;
import org.spongepowered.asm.mixin.Mixin;
import dev.shadowsoffire.apotheosis.ench.EnchModuleEvents;
import net.minecraft.world.entity.projectile.AbstractArrow;

@Mixin({ ThrownTrident.class })
public abstract class ThrownTridentMixin extends AbstractArrow implements EnchModuleEvents.TridentGetter
{
    int pierces;
    Vec3 oldVel;
    @Shadow
    private boolean f_37556_;
    
    protected ThrownTridentMixin(final EntityType<? extends AbstractArrow> type, final Level level) {
        super((EntityType)type, level);
        this.pierces = 0;
        this.oldVel = null;
    }
    
    @Accessor
    public abstract ItemStack getTridentItem();
    
    @Inject(method = { "<init>(Lnet/minecraft/world/level/Level;Lnet/minecraft/world/entity/LivingEntity;Lnet/minecraft/world/item/ItemStack;)V" }, at = { @At("TAIL") }, require = 1, remap = false)
    private void init(final CallbackInfo ci) {
        this.m_36767_((byte)this.getTridentItem().getEnchantmentLevel(Enchantments.f_44961_));
    }
    
    @Inject(method = { "onHitEntity(Lnet/minecraft/world/phys/EntityHitResult;)V" }, at = { @At("HEAD") }, cancellable = true, require = 1)
    public void startHitEntity(final EntityHitResult res, final CallbackInfo ci) {
        if (this.m_36796_() > 0 && !this.m_36797_()) {
            if (this.f_36701_ == null) {
                this.f_36701_ = new IntOpenHashSet((int)this.m_36796_());
            }
            if (this.f_36701_.contains(res.m_82443_().m_19879_())) {
                ci.cancel();
            }
            this.oldVel = this.m_20184_();
        }
    }
    
    @Inject(method = { "onHitEntity(Lnet/minecraft/world/phys/EntityHitResult;)V" }, at = { @At("TAIL") }, cancellable = true, require = 1)
    public void endHitEntity(final EntityHitResult res, final CallbackInfo ci) {
        if (this.m_36796_() > 0 && !this.m_36797_()) {
            this.f_36701_.add(res.m_82443_().m_19879_());
            if (this.f_36701_.size() <= this.m_36796_()) {
                this.f_37556_ = false;
                if (this.oldVel != null) {
                    this.m_20256_(this.oldVel);
                }
            }
        }
    }
}
